#ifndef NATIVE_DIALOG_H
#define NATIVE_DIALOG_H

#include "ndialog.h"

namespace NativeDialog {

enum DlgType {
    DLG_OK = NDIALOG_DLG_OK,
    DLG_OKCANCEL = NDIALOG_DLG_OKCANCEL,
    DLG_YESNO = NDIALOG_DLG_YESNO
};

enum BtnType {
    BTN_NONE = NDIALOG_BTN_NONE,
    BTN_OK = NDIALOG_BTN_OK,
    BTN_CANCEL = NDIALOG_BTN_CANCEL,
    BTN_YES = NDIALOG_BTN_YES,
    BTN_NO = NDIALOG_BTN_NO
};

enum MsgType {
    MSG_INFO = NDIALOG_MSG_INFO,
    MSG_WARNING = NDIALOG_MSG_WARNING,
    MSG_ERROR = NDIALOG_MSG_ERROR,
    MSG_QUESTION = NDIALOG_MSG_QUESTION
};

enum ErrType {
    ERR_NONE = NDIALOG_ERR_NONE,
    ERR_BUF = NDIALOG_ERR_BUF2SMALL,
    ERR_NOMEM = NDIALOG_ERR_NOMEM,
    ERR_INVENC = NDIALOG_ERR_INVENC,
    ERR_INVARG = NDIALOG_ERR_INVARG,
    ERR_SYSERR = NDIALOG_ERR_SYSERR,
    ERR_NOTIMP = NDIALOG_ERR_NOTIMP,
    ERR_UNKNOWN = NDIALOG_ERR_UNKNOWN
};

BtnType MessageBox( Window *Parent, const SimpleString& Title, const SimpleString& Message, const MsgType Msgtype = MSG_INFO, const DlgType Dlgtype = DLG_OK );
SimpleString SaveFile( Window *Parent, const SimpleString Title, const SimpleString Path, const Array<SimpleString>& Filters, const bool AllowCreateFolder = true, const bool AskOverwrite = true );
SimpleString OpenFile( Window *Parent, const SimpleString Title, const SimpleString Path, const Array<SimpleString>& Filters, const bool AllowMultiple = false, int* NumRes = 0 );
ErrType LastError();

}

#endif // NATIVE_DIALOG_H
